using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.InputSystem;

public class PlayerMove_event : MonoBehaviour
{
    CharacterController characterController;
    PlayerInput playerInput;
    Animator animator;

    // ړx
    private float walkSpeed = 2f;
    private float sprintSpeedUpRatio = 4f;
    private float rotationSpeed = 720f;

    private Vector2 input = Vector2.zero;
    private bool isRunning = false;

    void Start()
    {
        characterController = GetComponent<CharacterController>();
        playerInput = GetComponent<PlayerInput>();
        animator = GetComponent<Animator>();
    }

    void Update()
    {
        var velocity = Vector3.zero;

        if (input.magnitude != 0)
        {
            Vector3 playerDirection = Vector3.Normalize(new Vector3(input.x, 0, input.y));
            Quaternion characterTargetRotation = Quaternion.LookRotation(playerDirection);
            transform.rotation = Quaternion.RotateTowards(transform.rotation, characterTargetRotation, rotationSpeed * Time.deltaTime);
        }

        float speedByStick = input.magnitude;
        float moveSpeed = walkSpeed * speedByStick;

        if (isRunning)
        {
            moveSpeed *= sprintSpeedUpRatio;
        }
        velocity = transform.forward * moveSpeed;

        // Aj[V̑xݒ
        animator.SetFloat("Speed", moveSpeed);

        // LN^[ړ
        characterController.Move(velocity * Time.deltaTime);

        Debug.Log("isRunnging : " + isRunning.ToString());
    }

    public void OnMoveEvent(InputAction.CallbackContext context)
    {
        input = context.ReadValue<Vector2>();
    }

    public void OnSprintEvent(InputAction.CallbackContext context)
    {
        // {^̏Ԃ𒲂ׂ邾Ȃ玟̍słǂ
        // isRunning = context.ReadValueAsButton();

        // {^ꂽƂAꂽƂŏꍇ̂悤ɏ
        switch (context.phase)
        {
            case InputActionPhase.Performed:
                isRunning = true;
                break;
            case InputActionPhase.Canceled:
                isRunning = false;
                break;
        }
    }
}
